var request = require('request'),
querystring = require('querystring');


/*request('http://craig:condons@localhost:9003/garden/apps', function(err, response, body) 
{
    console.log(body);
});*/



module.exports = new function()
{

    var host = 'localhost', port = 9003, self = this;
    
    
    var _request = this.request = function(opsOrPath, callback)
    {
    
        var ops = {};
        
        if(typeof opsOrPath == 'string')
        {
            ops.path = opsOrPath;
        }
        else
        {
            ops = opsOrPath;
        }
    
        var qs = '';
        
        if(ops.data) qs = '?' + querystring.stringify(ops.data);
        
        request[ops.method || 'get']('http://'+self.username+':'+self.password+'@'+host+':'+port+'/' + ops.path + qs, function(err, response, body)
        {
            try
            {
                callback(false, JSON.parse(body));
            }
            catch(e)
            {
                console.log(body);
                console.log(e.stack);
                
                callback(true);
            }
        });
    }
    
    this.setAuth = function(user, pass)
    {
        self.username = user;
        self.password = pass;
    }
    
    this.validate = function(callback)
    {
        _request({ path: '/auth' }, callback);
    }
    
    this.signup = function(email, user, pass, callback)
    {
        self.username = user;
        self.password = pass;

        _request({ method: 'post', path: '/auth', data: { email: email, username: user, password: pass } }, callback);
    }
}